/* No main, no mess? TÄYSIN epästandardia meininkiä on nyt -
 * ainoastaan koulutuksellisessa tarkoituksessa sen demonstroimiseksi,
 * että C on taipuu lähemmäksi rautaa kuin käytännössä ikinä
 * tarvitsee. Johtopäätös saisi olla: se taipuu kyllä riittävän
 * lähelle ihan standardinmukaisia menetelmiäkin käyttäen!
 *
 * Tämän voi kääntää seuraavasti:
 *
 *   gcc -o hello_no_main -nostartfiles -nostdlib  l05_helnolibs.c
 *
 * Tällöin kääntäjä jättää pois kaikki standardikirjastot, jopa
 * kaikkein primitiivisimmät, joissa hoidetaan myös
 * alustustoimenpiteet ja main()-aliohjelman kutsuminen. Ei siis auta
 * kuin määritellä symboli _start, johon suoritus hyppää suoraan, kun
 * prosessi saa käyttöjärjestelmältä ensimmäisen
 * suoritusvuoronsa. Kaikki kirjastojen takana oleva, mukaanlukien
 * käyttöjärjestelmän palvelut tulostamiseen ja ohjelman
 * lopettamiseen, olisi pakko kirjoittaa assemblerilla, jos kirjastoja
 * ei olisi käytössä.
 *
 */

void _start(){
  /* x64-64 needs stack alignment(?) should check...*/
  asm ("and $0xfffffffffffffff0,%rsp");

  const char *mjono="Hello world.\n";
  const int pituus=13;

  /* Linux x86_64 syscall for write: */
  /* (rax==1 ; rdi==file desc. ; rsi==buffer ; rdx==nbytes) */
  asm(
    "movq $1,%%rdi\n;"
    "movq %0,%%rsi\n;"
    "movq %1,%%rdx\n;"
    "movq $1,%%rax\n;"
    "syscall\n"
    :
    : "r"(mjono), "r"((long long int)pituus)
      );
  
  /* Linux x86_64 syscall for exit */
  /* (rax==60 ; rdi==exit code): */
  asm(
    "movq $0,%rdi\n;"
    "movq $60,%rax\n;"
    "syscall\n"
  );
}
